Subversion Repositories ALCASAR

Rev

Rev 2741 | Rev 2743 | Go to most recent revision | Blame | Compare with Previous | Last modification | View Log | RSS feed

By Rexy

ALCASAR need the following programs that don't be included as RPM in Mageia :
  - coovachilli (the captive portal)
  - havp (http antivirus proxy)
  - ipt_netflow kernel module (netflow log system)
  - wkhtmltopdf (html to pdf renderer)
  - nfdump (collector & processor for netflow data)

This howto explains how to build RPM of these programs in order to keep the distribution clean

****  Prepare the RPM creation structure ***
- upadate your system : urpmi --auto-update
- install the following RPMs "kernel-userspace-headers", "rpm-build", "gengetopt", "libtool" packages
- create directories structure in your home : mkdir -p ~/rpmbuild/{SRPMS,SOURCES,SPECS,tmp}
- Option : find the ".rpmmacros" file on mageia wiki (https://wiki.mageia.org/en/Packagers_RPM_tutorial) and copy it in your home directory

****  For Coova-chilli   *****
- retrieve the last tarball of coova-chilli (or the svn archive).
- Untar it and test the compilation process ("sh ./bootstrap", "./configure --enable-json --enable-libjson --enable-mdns", "make", "make install").
- all is in the /usr/local". Remove the instaled files ("make uninstall") and the binaries ("make clean").
- rename the directory and compress it (ie : tar -cvzf coova-chilli-1.4.tar.gz coova-chilli-1.4). Copy this tarball in the directory ~/rpmbuild/SOURCES/.
- copy the SPEC file from the ALCASAR archive to the directory ~/rpmbuild/SPEC
- change to the directory ~/pmbuild/SPEC and run the RPM build process excluding 'ssl' : "rpmbuild -bb coova-chilli.spec" (or rpmbuild -ba to create also the SRPMS) 

INFO : .spec modifications since Redhat RPM :
        - add this 1st line : "%define _disable_ld_no_undefined 1" to avoid errors for unused variables
        - for 64b version, add 2 lines with "lib64" directory on the section removing statics binaries (rm -rf $RPM_BUILD_ROOT/usr/lib/*.la)
        - remove from the archive the unuused files for ALCASAR (wpad.dat, wwwdir, etc. via la directive '%exclude')
        - change %make (deprecated) with %make_build and change %makeinstall (deprecated) with %make_install 

**** For HAVP ****
- install the RPM of clamav-devel
- download, uncompress, and test the compilation of the last version of havp (./configure + make)
- copy the tarball in ~/rpmbuild/SOURCES/. copy the patch file ("havp-init.diff") in ~/rpmbuil/SOURCE. Copy and adapt the .spec in ~/rpmbuid/SPEC
- rpmbuild -bb ***.spec

****  For ipt_netflow  ****
- Must be complied on a system which runs the target kernel. So install manually the targeted kernel and reboot (ipt_NETFLOW will not load during this reboot) 
- install the RPMs "kernel-server-devel" (choose the targeted kernel), "lib64iptables-devel (or libiptables-devel in 32b arch)"
- download, uncompress and test the compilation of the last version of ipt-netflow (./configure --disable-dkms --disable-snmp-agent, make all install). The module is compiled in the same directory. The libs are copied in the /lib64/iptables (libip6t_NETFLOW.so & libipt_NETFLOW.so)
- test the module : go to the directory of sources and try to load it (depmod + modprobe ipt_NETFLOW), look at "journalctrl -f" and run "lsmod|grep ipt_NETFLOW" to verify if it's loaded. Run "alcasar-iptables.sh" to reload netfilter rules (no errors should appear). Run "alcasar-daemon.sh" to verify that all is ok.
- if all is ok, copy the tarball in rpmbuild/SOURCES. Copy and adapt the .spec in rpmbuild/SPECS (change the versions of kernel and rpm).
- change to the directory ~/pmbuild/SPEC and run "rpmbuild -bb ****.spec"
- install the fresh rpm (urpmi) and load ALCASAR iptables rules (alcasar-iptables.sh). Great job ;-) 

**** For wkhtmltopdf ****
- download the archive of the binaries of the last version (https://wkhtmltopdf.org/downloads.html) in ~/rpmbuild/SOURCES/wkhtmltox-%{version}_linux-generic-amd64.tar.xz.
- build with: rpmbuild -bb --clean wkhtmltopdf-%{version}-%{release}.spec

**** For nfdump ****
- install lib64rrdtool-devel, bison, flex